UPGRADE FROM 2.1 to 2.2
=======================

Table of Contents
-----------------

- [ActionBundle](#actionbundle)
- [ActivityBundle](#activitybundle)
- [ActivityListBundle](#activitylistbundle)
- [ApiBundle](#apibundle)
- [AttachmentBundle](#attachmentbundle)
- [ConfigBundle](#configbundle)
- [CronBundle](#cronbundle)
- [DataAuditBundle](#dataauditbundle)
- [DistributionBundle](#distributionbundle)
- [EmailBundle](#emailbundle)
- [FormBundle](#formbundle)
- [ImapBundle](#imapbundle)
- [ImportExportBundle](#importexportbundle)
- [InstallerBundle](#installerbundle)
- [IntegrationBundle](#integrationbundle)
- [LayoutBundle](#layoutbundle)
- [NavigationBundle](#navigationbundle)
- [PlatformBundle](#platformbundle)
- [SecurityBundle](#securitybundle)
- [SegmentBundle](#segmentbundle)
- [TranslationBundle](#translationbundle)
- [UIBundle](#uibundle)
- [WorkflowBundle](#workflowbundle)
- [Action Component](#action-component)

ActionBundle
------------
* The `ButtonListener`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Datagrid/EventListener/ButtonListener.php "Oro\Bundle\ActionBundle\Datagrid\EventListener\ButtonListener")</sup> class was removed. Logic was transferred to `DatagridActionButtonProvider`<sup>[[?]](https://github.com/laboro/dev/blob/maintenance/2.2/package/platform/src/Oro/Bundle/ActionBundle/Datagrid/Provider/DatagridActionButtonProvider.php "Oro\Bundle\ActionBundle\Datagrid\Provider\DatagridActionButtonProvider")</sup> class.
* Service `oro_action.datagrid.event_listener.button` was removed and new `oro_action.datagrid.action.button_provider` added with tag `oro_datagrid.extension.action.provider`
* The `AttributeGuesser`<sup>[[?]](https://github.com/laboro/dev/blob/maintenance/2.2/package/platform/src/Oro/Bundle/ActionBundle/Model/AttributeGuesser.php "Oro\Bundle\ActionBundle\Model\AttributeGuesser")</sup> class now extends `Oro\Bundle\ActionBundle\Model\AbstractGuesser`<sup>[[?]](https://github.com/laboro/dev/blob/maintenance/2.2/package/platform/src/Oro/Bundle/ActionBundle/Model/AbstractGuesser.php "Oro\Bundle\ActionBundle\Model\AbstractGuesser")</sup>
* Service `oro_action.attribute_guesser` has parent defined as `oro_action.abstract_guesser`
* The following methods in class `AttributeGuesser`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ActionBundle/Model/AttributeGuesser.php "Oro\Bundle\ActionBundle\Model\AttributeGuesser")</sup> were removed:
   - `guessAttributeParametersScalarField`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Model/AttributeGuesser.php#L328 "Oro\Bundle\ActionBundle\Model\AttributeGuesser::guessAttributeParametersScalarField")</sup>
* The following methods in class `OperationButtonProviderExtension`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Extension/OperationButtonProviderExtension.php#L187 "Oro\Bundle\ActionBundle\Extension\OperationButtonProviderExtension")</sup> were removed:
   - `resolveOptions`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Extension/OperationButtonProviderExtension.php#L187 "Oro\Bundle\ActionBundle\Extension\OperationButtonProviderExtension::resolveOptions")</sup>
   - `resolveValues`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Extension/OperationButtonProviderExtension.php#L197 "Oro\Bundle\ActionBundle\Extension\OperationButtonProviderExtension::resolveValues")</sup>
* The following properties in class `OperationButtonProviderExtension`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Extension/OperationButtonProviderExtension.php#L34 "Oro\Bundle\ActionBundle\Extension\OperationButtonProviderExtension")</sup> were removed:
   - `$optionsAssembler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Extension/OperationButtonProviderExtension.php#L34 "Oro\Bundle\ActionBundle\Extension\OperationButtonProviderExtension::$optionsAssembler")</sup>
   - `$contextAccessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Extension/OperationButtonProviderExtension.php#L37 "Oro\Bundle\ActionBundle\Extension\OperationButtonProviderExtension::$contextAccessor")</sup>
* The `OperationButtonProviderExtension::__construct(OperationRegistry $operationRegistry, ContextHelper $contextHelper, RouteProviderInterface $routeProvider, OptionsAssembler $optionsAssembler, ContextAccessor $contextAccessor)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Extension/OperationButtonProviderExtension.php#L49 "Oro\Bundle\ActionBundle\Extension\OperationButtonProviderExtension")</sup> method was changed to `OperationButtonProviderExtension::__construct(OperationRegistry $operationRegistry, ContextHelper $contextHelper, RouteProviderInterface $routeProvider, OptionsResolver $optionsResolver)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ActionBundle/Extension/OperationButtonProviderExtension.php#L43 "Oro\Bundle\ActionBundle\Extension\OperationButtonProviderExtension")</sup>
* The `AjaxController::handleResponse(Request $request, ActionData $data, $code, $message, Collection $errorMessages)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActionBundle/Controller/AjaxController.php#L76 "Oro\Bundle\ActionBundle\Controller\AjaxController")</sup> method was changed to `AjaxController::handleResponse(Request $request, ActionData $data, $code, $message, Collection $errorMessages, bool $pageReload)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ActionBundle/Controller/AjaxController.php#L79 "Oro\Bundle\ActionBundle\Controller\AjaxController")</sup>

ActivityBundle
--------------
* The `ContextGridProvider`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActivityBundle/Provider/ContextGridProvider.php#L11 "Oro\Bundle\ActivityBundle\Provider\ContextGridProvider")</sup> class was removed.
* The `ActivityController::contextGridAction`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActivityBundle/Controller/ActivityController.php#L97 "Oro\Bundle\ActivityBundle\Controller\ActivityController::contextGridAction")</sup> method was removed.

ActivityListBundle
------------------
* The following methods in class `ActivityListListener`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ActivityListBundle/EventListener/ActivityListListener.php "Oro\Bundle\ActivityListBundle\EventListener\ActivityListListener")</sup> were removed:
   - `collectUpdates::collectUpdates`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActivityListBundle/EventListener/ActivityListListener.php#L122 "Oro\Bundle\ActivityListBundle\EventListener\ActivityListListener::collectUpdates")</sup>
   - `collectUpdatesOwnerEntities::collectUpdatesOwnerEntities`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActivityListBundle/EventListener/ActivityListListener.php#L154 "Oro\Bundle\ActivityListBundle\EventListener\ActivityListListener::collectUpdatesOwnerEntities")</sup>
   - `collectInsertedOwnerEntities::collectInsertedOwnerEntities`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActivityListBundle/EventListener/ActivityListListener.php#L201 "Oro\Bundle\ActivityListBundle\EventListener\ActivityListListener::collectInsertedOwnerEntities")</sup>
* The `ActivityListListener::collectDeletedEntities($entities)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ActivityListBundle/EventListener/ActivityListListener.php#L101 "Oro\Bundle\ActivityListBundle\EventListener\ActivityListListener")</sup> method was changed to `ActivityListListener::collectDeletedEntities(array $entities)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ActivityListBundle/EventListener/ActivityListListener.php#L105 "Oro\Bundle\ActivityListBundle\EventListener\ActivityListListener")</sup>

ApiBundle
---------
* Added `form_event_subscriber` option to `Resources/config/oro/api.yml`. It can be used to add an event subscriber(s) to a form of such actions as `create`, `update`, `add_relationship`, `update_relationship` and `delete_relationship`. For details see `/src/Oro/Bundle/ApiBundle/Resources/doc/configuration.md`
* Fixed handling of `property_path` option from `api.yml` for cases when the property path contains several fields, e.g. `customerAssociation.account`
* Changed implementation of `LoadExtendedAssociation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation")</sup> and `LoadNestedAssociation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation")</sup> processors
    - now they are extend new base processor `Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadCustomAssociation`
* The `DoctrineHelper::findEntityMetadataByPath($entityClass, array $associationPath)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Util/DoctrineHelper.php#L43 "Oro\Bundle\ApiBundle\Util\DoctrineHelper")</sup> method was changed to `DoctrineHelper::findEntityMetadataByPath($entityClass, $associationPath)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Util/DoctrineHelper.php#L43 "Oro\Bundle\ApiBundle\Util\DoctrineHelper")</sup>
* The following methods in class `BuildFormBuilder`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Shared/BuildFormBuilder.php "Oro\Bundle\ApiBundle\Processor\Shared\BuildFormBuilder")</sup> were changed:
  > - `__construct(FormFactoryInterface $formFactory)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Shared/BuildFormBuilder.php#L28 "Oro\Bundle\ApiBundle\Processor\Shared\BuildFormBuilder")</sup>
  > - `__construct(FormHelper $formHelper)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Shared/BuildFormBuilder.php#L26 "Oro\Bundle\ApiBundle\Processor\Shared\BuildFormBuilder")</sup>

  > - `__construct(FormFactoryInterface $formFactory, PropertyAccessorInterface $propertyAccessor)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/AddRelationship/BuildFormBuilder.php#L25 "Oro\Bundle\ApiBundle\Processor\Subresource\AddRelationship\BuildFormBuilder")</sup>
  > - `__construct(FormHelper $formHelper, PropertyAccessorInterface $propertyAccessor)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/AddRelationship/BuildFormBuilder.php#L25 "Oro\Bundle\ApiBundle\Processor\Subresource\AddRelationship\BuildFormBuilder")</sup>

* The `NestedObjectMetadataHelper::addNestedObjectAssociation(EntityMetadata $entityMetadata, $entityClass, $fieldName, EntityDefinitionFieldConfig $field, $targetAction)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/GetMetadata/Loader/NestedObjectMetadataHelper.php#L41 "Oro\Bundle\ApiBundle\Processor\GetMetadata\Loader\NestedObjectMetadataHelper")</sup> method was changed to `NestedObjectMetadataHelper::addNestedObjectAssociation(EntityMetadata $entityMetadata, $entityClass, EntityDefinitionConfig $config, $fieldName, EntityDefinitionFieldConfig $field, $targetAction)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/GetMetadata/Loader/NestedObjectMetadataHelper.php#L41 "Oro\Bundle\ApiBundle\Processor\GetMetadata\Loader\NestedObjectMetadataHelper")</sup>
* The `ObjectMetadataFactory::createAndAddAssociationMetadata(EntityMetadata $entityMetadata, $entityClass, $fieldName, EntityDefinitionFieldConfig $field, $targetAction, $targetClass = null)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/GetMetadata/Loader/ObjectMetadataFactory.php#L117 "Oro\Bundle\ApiBundle\Processor\GetMetadata\Loader\ObjectMetadataFactory")</sup> method was changed to `ObjectMetadataFactory::createAndAddAssociationMetadata(EntityMetadata $entityMetadata, $entityClass, EntityDefinitionConfig $config, $fieldName, EntityDefinitionFieldConfig $field, $targetAction, $targetClass = null)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/GetMetadata/Loader/ObjectMetadataFactory.php#L119 "Oro\Bundle\ApiBundle\Processor\GetMetadata\Loader\ObjectMetadataFactory")</sup>
* The following properties in class `BuildFormBuilder`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/BuildFormBuilder.php "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\BuildFormBuilder")</sup> were removed:
   - `$formFactory::$formFactory`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/BuildFormBuilder.php#L20 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\BuildFormBuilder::$formFactory")</sup>
   - `$formFactory::$formFactory`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Shared/BuildFormBuilder.php#L23 "Oro\Bundle\ApiBundle\Processor\Shared\BuildFormBuilder::$formFactory")</sup>
   - `$propertyAccessor::$propertyAccessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Create/BuildFormBuilder.php#L19 "Oro\Bundle\ApiBundle\Processor\Create\BuildFormBuilder::$propertyAccessor")</sup>
* The following properties in class `LoadExtendedAssociation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation")</sup> were removed:
   - `$entitySerializer::$entitySerializer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php#L23 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation::$entitySerializer")</sup>
   - `$doctrineHelper::$doctrineHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php#L26 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation::$doctrineHelper")</sup>
* The following properties in class `LoadNestedAssociation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation")</sup> were removed:
   - `$entitySerializer::$entitySerializer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php#L22 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation::$entitySerializer")</sup>
   - `$doctrineHelper::$doctrineHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php#L25 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation::$doctrineHelper")</sup>
* The `BuildFormBuilder::__construct`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Create/BuildFormBuilder.php#L25 "Oro\Bundle\ApiBundle\Processor\Create\BuildFormBuilder::__construct")</sup> method was removed.
* Static class `FormUtil`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Form/FormUtil.php#L15 "Oro\Bundle\ApiBundle\Form\FormUtil")</sup> was replaced with `FormHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Form/FormHelper.php "Oro\Bundle\ApiBundle\Form\FormHelper")</sup> which is available as a service `oro_api.form_helper`
* The following methods in class `FormUtil`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Form/FormUtil.php "Oro\Bundle\ApiBundle\Form\FormUtil")</sup> were removed:
   - `getFormDefaultOptions::getFormDefaultOptions`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Form/FormUtil.php#L15 "Oro\Bundle\ApiBundle\Form\FormUtil::getFormDefaultOptions")</sup>
   - `getFormFieldOptions::getFormFieldOptions`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Form/FormUtil.php#L30 "Oro\Bundle\ApiBundle\Form\FormUtil::getFormFieldOptions")</sup>
* The following methods in class `LoadExtendedAssociation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation")</sup> were removed:
   - `__construct::__construct`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php#L32 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation::__construct")</sup>
   - `process::process`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php#L41 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation::process")</sup>
   - `getExtendedAssociationType::getExtendedAssociationType`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php#L72 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation::getExtendedAssociationType")</sup>
   - `isCollection::isCollection`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php#L94 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation::isCollection")</sup>
   - `loadData::loadData`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php#L116 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation::loadData")</sup>
   - `getQueryBuilder::getQueryBuilder`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadExtendedAssociation.php#L141 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadExtendedAssociation::getQueryBuilder")</sup>
   - `getAssociationTargets::getAssociationTargets`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/GetSubresource/LoadExtendedAssociation.php#L150 "Oro\Bundle\ApiBundle\Processor\Subresource\GetSubresource\LoadExtendedAssociation::getAssociationTargets")</sup>
* The following methods in class `LoadNestedAssociation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation")</sup> were removed:
   - `__construct::__construct`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php#L31 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation::__construct")</sup>
   - `process::process`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php#L40 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation::process")</sup>
   - `isNestedAssociation::isNestedAssociation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php#L70 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation::isNestedAssociation")</sup>
   - `loadData::loadData`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php#L85 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation::loadData")</sup>
   - `getQueryBuilder::getQueryBuilder`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/Shared/LoadNestedAssociation.php#L110 "Oro\Bundle\ApiBundle\Processor\Subresource\Shared\LoadNestedAssociation::getQueryBuilder")</sup>
* The `BuildFormBuilder::addFormFields`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Shared/BuildFormBuilder.php#L97 "Oro\Bundle\ApiBundle\Processor\Shared\BuildFormBuilder::addFormFields")</sup> method was removed.
* The `NormalizeMetadata::findFieldByPropertyPath`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/GetMetadata/NormalizeMetadata.php#L255 "Oro\Bundle\ApiBundle\Processor\GetMetadata\NormalizeMetadata::findFieldByPropertyPath")</sup> method was removed.
* Changed implementation of `CompleteDefinition`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/CompleteDefinition.php#L130 "Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition")</sup> processor. All logic was moved to the following classes:
    - `Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition\CompleteAssociationHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/CompleteDefinition/CompleteAssociationHelper.php#L130 "Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition\CompleteAssociationHelper")</sup>
    - `Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition\CompleteCustomAssociationHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/CompleteDefinition/CompleteCustomAssociationHelper.php#L130 "Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition\CompleteCustomAssociationHelper")</sup>
    - `Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition\CompleteEntityDefinitionHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/CompleteDefinition/CompleteEntityDefinitionHelper.php#L130 "Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition\CompleteEntityDefinitionHelper")</sup>
    - `Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition\CompleteObjectDefinitionHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/CompleteDefinition/CompleteObjectDefinitionHelper.php#L130 "Oro\Bundle\ApiBundle\Processor\Config\Shared\CompleteDefinition\CompleteObjectDefinitionHelper")</sup>
* The following methods in class `ExpandRelatedEntities`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/ExpandRelatedEntities.php "Oro\Bundle\ApiBundle\Processor\Config\Shared\ExpandRelatedEntities")</sup> were removed:
   - `getAssociationData`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/ExpandRelatedEntities.php#L136 "Oro\Bundle\ApiBundle\Processor\Config\Shared\ExpandRelatedEntities::getAssociationData")</sup>
   - `updateRelatedFieldTargetEntity`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/ExpandRelatedEntities.php#L255 "Oro\Bundle\ApiBundle\Processor\Config\Shared\ExpandRelatedEntities::updateRelatedFieldTargetEntity")</sup>
* The `LoadExtendedAssociation::addTitles(array $data, $parentEntityClass, $parentEntityId, EntityDefinitionFieldConfig $association, $titleFieldName)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/GetSubresource/LoadExtendedAssociation.php#L84 "Oro\Bundle\ApiBundle\Processor\Subresource\GetSubresource\LoadExtendedAssociation")</sup> method was changed to `LoadExtendedAssociation::addTitles(array $data, $associationOwnerClass, $associationOwnerId, $associationType, $associationKind, $titleFieldName)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/GetSubresource/LoadExtendedAssociation.php#L105 "Oro\Bundle\ApiBundle\Processor\Subresource\GetSubresource\LoadExtendedAssociation")</sup>
* The `LoadNestedAssociation::loadData(SubresourceContext $context, $associationName)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/GetSubresource/LoadNestedAssociation.php#L40 "Oro\Bundle\ApiBundle\Processor\Subresource\GetSubresource\LoadNestedAssociation")</sup> method was changed to `LoadNestedAssociation::loadData(SubresourceContext $context, $associationName, $isCollection)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Subresource/GetSubresource/LoadNestedAssociation.php#L40 "Oro\Bundle\ApiBundle\Processor\Subresource\GetSubresource\LoadNestedAssociation")</sup>
* The `ExpandRelatedEntities::completeEntityAssociations(ClassMetadata $metadata, EntityDefinitionConfig $definition, array $expandedEntities, $version, RequestType $requestType, array $extras)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/ExpandRelatedEntities.php#L83 "Oro\Bundle\ApiBundle\Processor\Config\Shared\ExpandRelatedEntities")</sup> method was changed to `ExpandRelatedEntities::completeEntityAssociations(ClassMetadata $metadata, EntityDefinitionConfig $definition, $expandedEntities, $version, RequestType $requestType, array $extras)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ApiBundle/Processor/Config/Shared/ExpandRelatedEntities.php#L83 "Oro\Bundle\ApiBundle\Processor\Config\Shared\ExpandRelatedEntities")</sup>

AttachmentBundle
----------------
* The `CustomWebPathResolver`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/AttachmentBundle/Imagine/Cache/Resolver/CustomWebPathResolver.php#L7 "Oro\Bundle\AttachmentBundle\Imagine\Cache\Resolver\CustomWebPathResolver")</sup> class was removed.
* The following methods in class `ImageResizer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/Resizer/ImageResizer.php "Oro\Bundle\AttachmentBundle\Resizer\ImageResizer")</sup> were changed:
  > - `__construct(AttachmentManager $attachmentManager, CacheManager $cacheManager, FileManager $fileManager, ImageFactory $imageFactory, $cacheResolverName)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/AttachmentBundle/Resizer/ImageResizer.php#L51 "Oro\Bundle\AttachmentBundle\Resizer\ImageResizer")</sup>
  > - `__construct(FileManager $fileManager, ImageFactory $imageFactory)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/Resizer/ImageResizer.php#L32 "Oro\Bundle\AttachmentBundle\Resizer\ImageResizer")</sup>

  > - `resizeImage(File $image, $filterName, $force)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/AttachmentBundle/Resizer/ImageResizer.php#L71 "Oro\Bundle\AttachmentBundle\Resizer\ImageResizer")</sup>
  > - `resizeImage(File $image, $filterName)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/AttachmentBundle/Resizer/ImageResizer.php#L45 "Oro\Bundle\AttachmentBundle\Resizer\ImageResizer")</sup>

ConfigBundle
------------
* The `ConfigFileDataTransformer::__construct(DoctrineHelper $doctrineHelper, ValidatorInterface $validator, FileManager $fileManager)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ConfigBundle/Form/DataTransformer/ConfigFileDataTransformer.php#L40 "Oro\Bundle\ConfigBundle\Form\DataTransformer\ConfigFileDataTransformer")</sup> method was changed to `ConfigFileDataTransformer::__construct(DoctrineHelper $doctrineHelper, ValidatorInterface $validator)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ConfigBundle/Form/DataTransformer/ConfigFileDataTransformer.php#L33 "Oro\Bundle\ConfigBundle\Form\DataTransformer\ConfigFileDataTransformer")</sup>
* The `ConfigSettingsUpdateEvent::setSettings($settings)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ConfigBundle/Event/ConfigSettingsUpdateEvent.php#L54 "Oro\Bundle\ConfigBundle\Event\ConfigSettingsUpdateEvent")</sup> method was changed to `ConfigSettingsUpdateEvent::setSettings(array $settings)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ConfigBundle/Event/ConfigSettingsUpdateEvent.php#L54 "Oro\Bundle\ConfigBundle\Event\ConfigSettingsUpdateEvent")</sup>
* The `AbstractScopeManager::__construct(ManagerRegistry $doctrine, CacheProvider $cache)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ConfigBundle/Config/AbstractScopeManager.php#L28 "Oro\Bundle\ConfigBundle\Config\AbstractScopeManager")</sup> method was changed to `AbstractScopeManager::__construct(ManagerRegistry $doctrine, CacheProvider $cache, EventDispatcherInterface $eventDispatcher)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ConfigBundle/Config/AbstractScopeManager.php#L34 "Oro\Bundle\ConfigBundle\Config\AbstractScopeManager")</sup>
   - abstract service `oro_config.scope_manager.abstract` now has third argument defined as `@event_dispatcher`

CronBundle
----------
* The `DeferredScheduler::__construct(ScheduleManager $scheduleManager, ManagerRegistry $registry, $scheduleClass)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/CronBundle/Entity/Manager/DeferredScheduler.php#L49 "Oro\Bundle\CronBundle\Entity\Manager\DeferredScheduler")</sup> method was changed to `DeferredScheduler::__construct(ScheduleManager $scheduleManager, ManagerRegistry $registry, SchedulesByArgumentsFilterInterface $schedulesByArgumentsFilter, $scheduleClass)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/CronBundle/Entity/Manager/DeferredScheduler.php#L52 "Oro\Bundle\CronBundle\Entity\Manager\DeferredScheduler")</sup>
* The `ScheduleManager::__construct(ManagerRegistry $registry, $scheduleClass)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/CronBundle/Entity/Manager/ScheduleManager.php#L23 "Oro\Bundle\CronBundle\Entity\Manager\ScheduleManager")</sup> method was changed to `ScheduleManager::__construct(ManagerRegistry $registry, SchedulesByArgumentsFilterInterface $schedulesByArgumentsFilter, $scheduleClass)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/CronBundle/Entity/Manager/ScheduleManager.php#L27 "Oro\Bundle\CronBundle\Entity\Manager\ScheduleManager")</sup>

DataAuditBundle
---------------
A new string field `ownerDescription` with the database column `owner_description` was added to the entity 
`Oro\Bundle\DataAuditBundle\Entity\Audit` and to the base class `Oro\Bundle\DataAuditBundle\Entity\AbstractAudit`

DataGridBundle
--------------
* Removed event `oro_datagrid.datagrid.extension.action.configure-actions.before`, now it is a call of `DatagridActionProviderInterface::hasActions`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/DatagridActionProviderInterface.php#L13 "Oro\Bundle\DataGridBundle\Extension\Action\DatagridActionProviderInterface")</sup> of registered through a `oro_datagrid.extension.action.provider` tag services.
* Interface `ManagerInterface`<sup>[[?]](https://github.com/laboro/dev/blob/maintenance/2.2/package/platform/src/Oro/Bundle/DataGridBundle/Datagrid/ManagerInterface.php#L18 "Oro\Bundle\DataGridBundle\Datagrid\ManagerInterface")</sup>
   - the signature of method `getDatagrid` was changed - added new parameter `array $additionalParameters = []`.
* Added abstract entity class `AbstractGridView`<sup>[[?]](https://github.com/laboro/dev/blob/maintenance/2.2/package/platform/src/Oro/Bundle/DataGridBundle/Entity/AbstractGridView.php "Oro\Bundle\DataGridBundle\Entity\AbstractGridView")</sup>
    - entity `GridView`<sup>[[?]](https://github.com/laboro/dev/blob/maintenance/2.2/package/platform/src/Oro/Bundle/DataGridBundle/Entity/GridView.php "Oro\Bundle\DataGridBundle\Entity\GridView")</sup> extends from it
* Added abstract entity class `AbstractGridViewUser`<sup>[[?]](https://github.com/laboro/dev/blob/maintenance/2.2/package/platform/src/Oro/Bundle/DataGridBundle/Entity/AbstractGridViewUser.php "Oro\Bundle\DataGridBundle\Entity\AbstractGridViewUser")</sup>
    - entity `GridViewUser`<sup>[[?]](https://github.com/laboro/dev/blob/maintenance/2.2/package/platform/src/Oro/Bundle/DataGridBundle/Entity/GridViewUser.php "Oro\Bundle\DataGridBundle\Entity\GridViewUser")</sup> extends from it
* The `ConfigureActionsBefore`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Extension/Action/Event/ConfigureActionsBefore.php#L10 "Oro\Bundle\DataGridBundle\Extension\Action\Event\ConfigureActionsBefore")</sup> class was removed.
* The `GridViewApiHandler::process(GridView $entity)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php#L57 "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup> method was changed to `GridViewApiHandler::process(AbstractGridView $entity)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php#L57 "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup>
* The `ActionExtension::__construct(ContainerInterface $container, SecurityFacade $securityFacade, TranslatorInterface $translator, EventDispatcherInterface $eventDispatcher)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L55 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension")</sup> method was changed to `ActionExtension::__construct(ContainerInterface $container, SecurityFacade $securityFacade, TranslatorInterface $translator)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L49 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension")</sup>
* The `GridViewRepository::findDefaultGridViews(AclHelper $aclHelper, UserInterface $user, GridView $gridView, $checkOwner = true)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Entity/Repository/GridViewRepository.php#L83 "Oro\Bundle\DataGridBundle\Entity\Repository\GridViewRepository")</sup> method was changed to `GridViewRepository::findDefaultGridViews(AclHelper $aclHelper, UserInterface $user, AbstractGridView $gridView, $checkOwner = true)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Entity/Repository/GridViewRepository.php#L83 "Oro\Bundle\DataGridBundle\Entity\Repository\GridViewRepository")</sup>
* The `GridViewApiEntityManager::setDefaultGridView(User $user, ViewInterface $gridView)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewApiEntityManager.php#L32 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewApiEntityManager")</sup> method was changed to `GridViewApiEntityManager::setDefaultGridView(AbstractUser $user, ViewInterface $gridView)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewApiEntityManager.php#L32 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewApiEntityManager")</sup>
* The following methods in class `GridViewManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup> were changed:
  > - `setDefaultGridView(User $user, ViewInterface $gridView, $default = true)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php#L74 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup>
  > - `setDefaultGridView(AbstractUser $user, ViewInterface $gridView, $default = true)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php#L100 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup>

  > - `getAllGridViews(User $user = null, $gridName = null)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php#L160 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup>
  > - `getAllGridViews(AbstractUser $user = null, $gridName = null)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php#L186 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup>

  > - `getDefaultView(User $user, $gridName)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php#L189 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup>
  > - `getDefaultView(AbstractUser $user, $gridName)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php#L216 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup>

* The following methods in class `GridViewApiHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup> were changed:
  > - `onSuccess(GridView $entity)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php#L85 "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup>
  > - `onSuccess(AbstractGridView $entity)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php#L85 "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup>

  > - `setDefaultGridView(GridView $gridView, $default)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php#L100 "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup>
  > - `setDefaultGridView(AbstractGridView $gridView, $default)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php#L100 "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup>

  > - `fixFilters(GridView $gridView)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php#L114 "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup>
  > - `fixFilters(AbstractGridView $gridView)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Form/Handler/GridViewApiHandler.php#L114 "Oro\Bundle\DataGridBundle\Form\Handler\GridViewApiHandler")</sup>

* The `GridViewManager::isViewDefault(ViewInterface $view, User $user)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php#L106 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup> method was changed to `GridViewManager::isViewDefault(ViewInterface $view, AbstractUser $user)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Entity/Manager/GridViewManager.php#L132 "Oro\Bundle\DataGridBundle\Entity\Manager\GridViewManager")</sup>
* The `GridViewController::checkSharedAccess(Request $request, GridView $view)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Controller/Api/Rest/GridViewController.php#L157 "Oro\Bundle\DataGridBundle\Controller\Api\Rest\GridViewController")</sup> method was changed to `GridViewController::checkSharedAccess(Request $request, AbstractGridView $view)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Controller/Api/Rest/GridViewController.php#L156 "Oro\Bundle\DataGridBundle\Controller\Api\Rest\GridViewController")</sup>
* The `ActionExtension::$eventDispatcher`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DataGridBundle/Extension/Action/ActionExtension.php#L41 "Oro\Bundle\DataGridBundle\Extension\Action\ActionExtension::$eventDispatcher")</sup> property was removed.
* Class `PreExportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Async/Export/PreExportMessageProcessor.php "Oro\Bundle\DataGridBundle\Async\Export\PreExportMessageProcessor")</sup> now extends `Oro\Bundle\ImportExportBundle\Async\Export\PreExportMessageProcessorAbstract` instead of implementing `ExportMessageProcessorAbstract` and `TopicSubscriberInterface`. Service calls `setExportHandler` with `@oro_datagrid.handler.export` and `setExportIdFetcher` with `@oro_datagrid.importexport.export_id_fetcher` were added. The constructor was removed, the parent class constructor is used.
* Class `ExportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DataGridBundle/Async/Export/ExportMessageProcessor.php "Oro\Bundle\DataGridBundle\Async\Export\ExportMessageProcessor")</sup> now extends `Oro\Bundle\ImportExportBundle\Async\Export\ExportMessageProcessorAbstract` instead of implementing `ExportMessageProcessorAbstract` and `TopicSubscriberInterface`. Service calls `setExportHandler` with `@oro_datagrid.handler.export`, `setExportConnector` with `@oro_datagrid.importexport.export_connector`, `setExportProcessor` with `@oro_datagrid.importexport.processor.export` and `setWriterChain`  with `@oro_importexport.writer.writer_chain` were added. The constructor was removed, the parent class constructor is used.

DistributionBundle
------------------
* The following methods in class `PackageController`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DistributionBundle/Controller/PackageController.php "Oro\Bundle\DistributionBundle\Controller\PackageController")</sup> were changed:
  > - `installAction()`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DistributionBundle/Controller/PackageController.php#L92 "Oro\Bundle\DistributionBundle\Controller\PackageController")</sup>
  > - `installAction(Request $request)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DistributionBundle/Controller/PackageController.php#L100 "Oro\Bundle\DistributionBundle\Controller\PackageController")</sup>

  > - `updateAction()`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/DistributionBundle/Controller/PackageController.php#L167 "Oro\Bundle\DistributionBundle\Controller\PackageController")</sup>
  > - `updateAction(Request $request)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/DistributionBundle/Controller/PackageController.php#L179 "Oro\Bundle\DistributionBundle\Controller\PackageController")</sup>


EmailBundle
-----------
* Class `Oro\Bundle\EmailBundle\Form\Type\AutoResponseRuleType`
    - form field `conditions` was removed. Use field `definition` instead.
* Class `Oro\Bundle\EmailBundle\Controller\AutoResponseRuleController`
    - action `update` now returns following data: `form`, `saved`, `data`, `metadata`
* template `Resources/views/Form/autoresponseFields.html.twig` was removed as it contained possibility to add collection item after arbitrary item, which is not needed anymore with new form
* template `Resources/views/AutoResponseRule/dialog/update.html.twig` was changed
* template `Resources/views/Configuration/Mailbox/update.html.twig` was changed
* template `EmailBundle/Resources/views/Form/fields.html.twig` was changed
* The following classes were removed:
   - `AutoResponseRuleConditionValidator`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Validator/AutoResponseRuleConditionValidator.php#L11 "Oro\Bundle\EmailBundle\Validator\AutoResponseRuleConditionValidator")</sup>
   - `AutoResponseRuleCondition`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Validator/Constraints/AutoResponseRuleCondition.php#L10 "Oro\Bundle\EmailBundle\Validator\Constraints\AutoResponseRuleCondition")</sup>
   - `AutoResponseRuleConditionType`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Form/Type/AutoResponseRuleConditionType.php#L11 "Oro\Bundle\EmailBundle\Form\Type\AutoResponseRuleConditionType")</sup>
   - `AutoResponseRuleCondition`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Entity/AutoResponseRuleCondition.php#L13 "Oro\Bundle\EmailBundle\Entity\AutoResponseRuleCondition")</sup>
* The `AutoResponseManager::__construct(Registry $registry, EmailModelBuilder $emailBuilder, Processor $emailProcessor, EmailRenderer $emailRender, LoggerInterface $logger, $defaultLocale)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Manager/AutoResponseManager.php#L85 "Oro\Bundle\EmailBundle\Manager\AutoResponseManager")</sup> method was changed to `AutoResponseManager::__construct(Registry $registry, EmailModelBuilder $emailBuilder, Processor $emailProcessor, EmailRenderer $emailRender, LoggerInterface $logger, TranslatorInterface $translator, $defaultLocale)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Manager/AutoResponseManager.php#L95 "Oro\Bundle\EmailBundle\Manager\AutoResponseManager")</sup>
* The `EmailQueryFactory::__construct(EmailOwnerProviderStorage $emailOwnerProviderStorage, EntityNameResolver $entityNameResolver, MailboxManager $mailboxManager, SecurityFacade $securityFacade)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L38 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory")</sup> method was changed to `EmailQueryFactory::__construct(EmailOwnerProviderStorage $emailOwnerProviderStorage, EntityNameResolver $entityNameResolver, MailboxManager $mailboxManager, SecurityFacade $securityFacade, FormFactoryInterface $formFactory, FilterUtility $filterUtil)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Datagrid/EmailQueryFactory.php#L54 "Oro\Bundle\EmailBundle\Datagrid\EmailQueryFactory")</sup>
* The following methods in class `AutoResponseRule`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/EmailBundle/Entity/AutoResponseRule.php "Oro\Bundle\EmailBundle\Entity\AutoResponseRule")</sup> were removed:
   - `getConditions::getConditions`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Entity/AutoResponseRule.php#L105 "Oro\Bundle\EmailBundle\Entity\AutoResponseRule::getConditions")</sup>
   - `addConditions::addConditions`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Entity/AutoResponseRule.php#L155 "Oro\Bundle\EmailBundle\Entity\AutoResponseRule::addConditions")</sup>
   - `addCondition::addCondition`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Entity/AutoResponseRule.php#L167 "Oro\Bundle\EmailBundle\Entity\AutoResponseRule::addCondition")</sup>
   - `removeCondition::removeCondition`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Entity/AutoResponseRule.php#L180 "Oro\Bundle\EmailBundle\Entity\AutoResponseRule::removeCondition")</sup>
* The `AutoResponseRule::$conditions`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/EmailBundle/Entity/AutoResponseRule.php#L46 "Oro\Bundle\EmailBundle\Entity\AutoResponseRule::$conditions")</sup> property was removed. Use methods related to `definition` property instead.

FormBundle
----------
* Form types `OroEncodedPlaceholderPasswordType`, `OroEncodedPasswordType` acquired `browser_autocomplete` option with default value set to `false`, which means that password autocomplete is off by default.
* The `OroEncodedPasswordType::setDefaultOptions`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/FormBundle/Form/Type/OroEncodedPasswordType.php#L65 "Oro\Bundle\FormBundle\Form\Type\OroEncodedPasswordType::setDefaultOptions")</sup> method was removed.

ImapBundle
----------
* The `ImapEmailManager::getAcceptLanguageHeader`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImapBundle/Manager/ImapEmailManager.php#L253 "Oro\Bundle\ImapBundle\Manager\ImapEmailManager::getAcceptLanguageHeader")</sup> method was removed.

ImportExportBundle
------------------
* Message topics `oro.importexport.cli_import`, `oro.importexport.import_http_validation`, `oro.importexport.import_http` with the constants were removed.
* Class `Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor` now extends `Oro\Bundle\ImportExportBundle\Async\Import\PreImportMessageProcessorAbstract` instead of implementing `ExportMessageProcessorAbstract` and `TopicSubscriberInterface`.
* Class `Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor` now extends `Oro\Bundle\ImportExportBundle\Async\Import\PreImportMessageProcessorAbstract` instead of implementing `ExportMessageProcessorAbstract` and `TopicSubscriberInterface`.
* Class `Oro\Bundle\ImportExportBundle\Async\Import\CliImportMessageProcessor`
    - does not implement TopicSubscriberInterface now.
    - subscribed topic moved to tag in `mq_processor.yml`.  
    - service `oro_importexport.async.http_import` decorates `oro_importexport.async.import`
* Class `Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor`
    - does not implement TopicSubscriberInterface now.
    - subscribed topic moved to tag in `mq_processor.yml`.  
    - service `oro_importexport.async.cli_import` decorates `oro_importexport.async.import`
* Class `Oro\Bundle\ImportExportBundle\Async\Export\PreExportMessageProcessor` now extends `Oro\Bundle\ImportExportBundle\Async\Export\PreExportMessageProcessorAbstract` instead of implementing `ExportMessageProcessorAbstract` and `TopicSubscriberInterface`. Service calls `setExportHandler` with `@oro_importexport.handler.export` and `setDoctrineHelper` with `@oro_entity.doctrine_helper` were added.
* Class `Oro\Bundle\ImportExportBundle\Async\Export\ExportMessageProcessor` now extends `Oro\Bundle\ImportExportBundle\Async\Export\ExportMessageProcessorAbstract` instead of implementing `ExportMessageProcessorAbstract` and `TopicSubscriberInterface`. Service calls `setExportHandler` with `@oro_importexport.handler.export` and `setDoctrineHelper` with `@oro_entity.doctrine_helper` were added.
* The `AbstractHandler::__construct(JobExecutor $jobExecutor, ProcessorRegistry $processorRegistry, ConfigProvider $entityConfigProvider, TranslatorInterface $translator, WriterChain $writerChain, ReaderChain $readerChain, BatchFileManager $batchFileManager)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Handler/AbstractHandler.php#L72 "Oro\Bundle\ImportExportBundle\Handler\AbstractHandler")</sup> method was changed to `AbstractHandler::__construct(JobExecutor $jobExecutor, ProcessorRegistry $processorRegistry, ConfigProvider $entityConfigProvider, TranslatorInterface $translator, WriterChain $writerChain, ReaderChain $readerChain, BatchFileManager $batchFileManager, FileManager $fileManager)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Handler/AbstractHandler.php#L79 "Oro\Bundle\ImportExportBundle\Handler\AbstractHandler")</sup>
* The `FileManager::saveImportingFile(File $file)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/File/FileManager.php#L34 "Oro\Bundle\ImportExportBundle\File\FileManager")</sup> method was changed to `FileManager::saveImportingFile(UploadedFile $file)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/File/FileManager.php#L34 "Oro\Bundle\ImportExportBundle\File\FileManager")</sup>
* The `ImportExportResultSummarizer::__construct(Router $router, ConfigManager $configManager)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/ImportExportResultSummarizer.php#L33 "Oro\Bundle\ImportExportBundle\Async\ImportExportResultSummarizer")</sup> method was changed to `ImportExportResultSummarizer::__construct(Router $router, ConfigManager $configManager, FileManager $fileManager)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/ImportExportResultSummarizer.php#L41 "Oro\Bundle\ImportExportBundle\Async\ImportExportResultSummarizer")</sup>
* The `HttpImportMessageProcessor::__construct(HttpImportHandler $httpImportHandler, JobRunner $jobRunner, MessageProducerInterface $producer, TokenStorageInterface $tokenStorage, ImportExportResultSummarizer $importExportResultSummarizer, JobStorage $jobStorage, LoggerInterface $logger, FileManager $fileManager)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L84 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor")</sup> method was changed to `HttpImportMessageProcessor::__construct(JobRunner $jobRunner, ImportExportResultSummarizer $importExportResultSummarizer, JobStorage $jobStorage, LoggerInterface $logger, FileManager $fileManager, HttpImportHandler $importHandler, PostponedRowsHandler $postponedRowsHandler, TokenSerializerInterface $tokenSerializer, TokenStorageInterface $tokenStorage)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L43 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor")</sup>
* The following methods in class `CliImportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Import/CliImportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Import\CliImportMessageProcessor")</sup> were removed:
   - `__construct::__construct`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/CliImportMessageProcessor.php#L60 "Oro\Bundle\ImportExportBundle\Async\Import\CliImportMessageProcessor::__construct")</sup>
   - `process::process`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/CliImportMessageProcessor.php#L79 "Oro\Bundle\ImportExportBundle\Async\Import\CliImportMessageProcessor::process")</sup>
   - `getSubscribedTopics::getSubscribedTopics`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/CliImportMessageProcessor.php#L145 "Oro\Bundle\ImportExportBundle\Async\Import\CliImportMessageProcessor::getSubscribedTopics")</sup>
* The following methods in class `HttpImportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor")</sup> were removed:
   - `setTokenSerializer::setTokenSerializer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L107 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::setTokenSerializer")</sup>
   - `process::process`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L115 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::process")</sup>
   - `getSubscribedTopics::getSubscribedTopics`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L187 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::getSubscribedTopics")</sup>
* The following methods in class `PreCliImportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor")</sup> were removed:
   - `__construct::__construct`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L80 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::__construct")</sup>
   - `setConfigManager::setConfigManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L103 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::setConfigManager")</sup>
   - `process::process`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L111 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::process")</sup>
* The following methods in class `PreHttpImportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor")</sup> were removed:
   - `__construct::__construct`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L93 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::__construct")</sup>
   - `setConfigManager::setConfigManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L116 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::setConfigManager")</sup>
   - `process::process`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L132 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::process")</sup>
* The following methods in class `ExportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Export/ExportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Export\ExportMessageProcessor")</sup> were removed:
   - `__construct::__construct`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Export/ExportMessageProcessor.php#L68 "Oro\Bundle\ImportExportBundle\Async\Export\ExportMessageProcessor::__construct")</sup>
   - `setTokenSerializer::setTokenSerializer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Export/ExportMessageProcessor.php#L87 "Oro\Bundle\ImportExportBundle\Async\Export\ExportMessageProcessor::setTokenSerializer")</sup>
   - `process::process`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Export/ExportMessageProcessor.php#L95 "Oro\Bundle\ImportExportBundle\Async\Export\ExportMessageProcessor::process")</sup>
* The following methods in class `PreExportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Export/PreExportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Export\PreExportMessageProcessor")</sup> were removed:
   - `__construct::__construct`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Export/PreExportMessageProcessor.php#L82 "Oro\Bundle\ImportExportBundle\Async\Export\PreExportMessageProcessor::__construct")</sup>
   - `setTokenSerializer::setTokenSerializer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Export/PreExportMessageProcessor.php#L105 "Oro\Bundle\ImportExportBundle\Async\Export\PreExportMessageProcessor::setTokenSerializer")</sup>
   - `process::process`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Export/PreExportMessageProcessor.php#L113 "Oro\Bundle\ImportExportBundle\Async\Export\PreExportMessageProcessor::process")</sup>
* The `CliImportMessageProcessor::saveJobResult`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/CliImportMessageProcessor.php#L133 "Oro\Bundle\ImportExportBundle\Async\Import\CliImportMessageProcessor::saveJobResult")</sup> method was removed.
* The `HttpImportMessageProcessor::saveJobResult`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L196 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::saveJobResult")</sup> method was removed.
* The following properties in class `HttpImportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor")</sup> were removed:
   - `$httpImportHandler::$httpImportHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L32 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::$httpImportHandler")</sup>
   - `$jobRunner::$jobRunner`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L37 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::$jobRunner")</sup>
   - `$producer::$producer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L42 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::$producer")</sup>
   - `$logger::$logger`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L52 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::$logger")</sup>
   - `$jobStorage::$jobStorage`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L57 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::$jobStorage")</sup>
   - `$importExportResultSummarizer::$importExportResultSummarizer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L62 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::$importExportResultSummarizer")</sup>
   - `$fileManager::$fileManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/HttpImportMessageProcessor.php#L67 "Oro\Bundle\ImportExportBundle\Async\Import\HttpImportMessageProcessor::$fileManager")</sup>
* The following properties in class `PreCliImportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor")</sup> were removed:
   - `$dependentJob::$dependentJob`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L43 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::$dependentJob")</sup>
   - `$fileManager::$fileManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L48 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::$fileManager")</sup>
   - `$cliImportHandler::$cliImportHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L53 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::$cliImportHandler")</sup>
   - `$writerChain::$writerChain`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L58 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::$writerChain")</sup>
   - `$configManager::$configManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L63 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::$configManager")</sup>
   - `$batchSize::$batchSize`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreCliImportMessageProcessor.php#L68 "Oro\Bundle\ImportExportBundle\Async\Import\PreCliImportMessageProcessor::$batchSize")</sup>
* The following properties in class `PreHttpImportMessageProcessor`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor")</sup> were removed:
   - `$jobRunner::$jobRunner`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L35 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$jobRunner")</sup>
   - `$producer::$producer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L40 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$producer")</sup>
   - `$logger::$logger`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L45 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$logger")</sup>
   - `$dependentJob::$dependentJob`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L50 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$dependentJob")</sup>
   - `$fileManager::$fileManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L55 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$fileManager")</sup>
   - `$httpImportHandler::$httpImportHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L60 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$httpImportHandler")</sup>
   - `$writerChain::$writerChain`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L65 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$writerChain")</sup>
   - `$configManager::$configManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L70 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$configManager")</sup>
   - `$batchSize::$batchSize`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/ImportExportBundle/Async/Import/PreHttpImportMessageProcessor.php#L80 "Oro\Bundle\ImportExportBundle\Async\Import\PreHttpImportMessageProcessor::$batchSize")</sup>

InstallerBundle
---------------
* The option `--force` was removed from `oro:install` cli command.
* The `CommandExecutor::getServer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/InstallerBundle/CommandExecutor.php#L401 "Oro\Bundle\InstallerBundle\CommandExecutor::getServer")</sup> method was removed.
* The following methods in class `InstallCommand`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/InstallerBundle/Command/InstallCommand.php "Oro\Bundle\InstallerBundle\Command\InstallCommand")</sup> were changed:
  > - `checkStep(OutputInterface $output)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/InstallerBundle/Command/InstallCommand.php#L171 "Oro\Bundle\InstallerBundle\Command\InstallCommand")</sup>
  > - `checkStep(InputInterface $input, OutputInterface $output)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/InstallerBundle/Command/InstallCommand.php#L184 "Oro\Bundle\InstallerBundle\Command\InstallCommand")</sup>

  > - `prepareStep(CommandExecutor $commandExecutor, InputInterface $input, OutputInterface $output)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/InstallerBundle/Command/InstallCommand.php#L207 "Oro\Bundle\InstallerBundle\Command\InstallCommand")</sup>
  > - `prepareStep(InputInterface $input, OutputInterface $output)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/InstallerBundle/Command/InstallCommand.php#L219 "Oro\Bundle\InstallerBundle\Command\InstallCommand")</sup>


IntegrationBundle
-----------------
* The `ReversSyncIntegrationProcessor::__construct(DoctrineHelper $doctrineHelper, ReverseSyncProcessor $reverseSyncProcessor, TypesRegistry $typesRegistry, JobRunner $jobRunner, LoggerInterface $logger)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/IntegrationBundle/Async/ReversSyncIntegrationProcessor.php#L63 "Oro\Bundle\IntegrationBundle\Async\ReversSyncIntegrationProcessor")</sup> method was changed to `ReversSyncIntegrationProcessor::__construct(DoctrineHelper $doctrineHelper, ReverseSyncProcessor $reverseSyncProcessor, TypesRegistry $typesRegistry, JobRunner $jobRunner, TokenStorageInterface $tokenStorage, LoggerInterface $logger)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/IntegrationBundle/Async/ReversSyncIntegrationProcessor.php#L67 "Oro\Bundle\IntegrationBundle\Async\ReversSyncIntegrationProcessor")</sup>
* The `SyncIntegrationProcessor::updateToken`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/IntegrationBundle/Async/SyncIntegrationProcessor.php#L153 "Oro\Bundle\IntegrationBundle\Async\SyncIntegrationProcessor::updateToken")</sup> method was removed.

LayoutBundle
------------
* The following methods in class `BaseTwigRendererEngine`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine")</sup> were removed:
   - `addDefaultThemes::addDefaultThemes`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L67 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::addDefaultThemes")</sup>
   - `getResourceForBlockName::getResourceForBlockName`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L112 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::getResourceForBlockName")</sup>
   - `getResourceHierarchyLevel::getResourceHierarchyLevel`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L161 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::getResourceHierarchyLevel")</sup>
   - `switchToNextParentResource::switchToNextParentResource`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L181 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::switchToNextParentResource")</sup>
* The following methods in class `TemplatingRendererEngine`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine")</sup> were removed:
   - `addDefaultThemes::addDefaultThemes`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L66 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::addDefaultThemes")</sup>
   - `getResourceForBlockName::getResourceForBlockName`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L76 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::getResourceForBlockName")</sup>
   - `getResourceHierarchyLevel::getResourceHierarchyLevel`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L129 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::getResourceHierarchyLevel")</sup>
   - `switchToNextParentResource::switchToNextParentResource`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L149 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::switchToNextParentResource")</sup>
* The following properties in class `BaseTwigRendererEngine`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine")</sup> were removed:
   - `$resources::$resources`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L26 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::$resources")</sup>
   - `$overrideResources::$overrideResources`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L31 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::$overrideResources")</sup>
   - `$parentResourceHierarchyLevels::$parentResourceHierarchyLevels`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L38 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::$parentResourceHierarchyLevels")</sup>
   - `$parentResourceOffsets::$parentResourceOffsets`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L47 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::$parentResourceOffsets")</sup>
   - `$resourcesHierarchy::$resourcesHierarchy`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/BaseTwigRendererEngine.php#L53 "Oro\Bundle\LayoutBundle\Form\BaseTwigRendererEngine::$resourcesHierarchy")</sup>
* The following properties in class `TemplatingRendererEngine`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine")</sup> were removed:
   - `$resources::$resources`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L24 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::$resources")</sup>
   - `$overrideResources::$overrideResources`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L29 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::$overrideResources")</sup>
   - `$parentResourceHierarchyLevels::$parentResourceHierarchyLevels`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L36 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::$parentResourceHierarchyLevels")</sup>
   - `$parentResourceOffsets::$parentResourceOffsets`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L45 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::$parentResourceOffsets")</sup>
   - `$resourcesHierarchy::$resourcesHierarchy`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/LayoutBundle/Form/RendererEngine/TemplatingRendererEngine.php#L51 "Oro\Bundle\LayoutBundle\Form\RendererEngine\TemplatingRendererEngine::$resourcesHierarchy")</sup>

NavigationBundle
----------------
* The following methods in class `AnnotationsReader`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Title/TitleReader/AnnotationsReader.php "Oro\Bundle\NavigationBundle\Title\TitleReader\AnnotationsReader")</sup> were removed:
   - `setRouter::setRouter`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/NavigationBundle/Title/TitleReader/AnnotationsReader.php#L40 "Oro\Bundle\NavigationBundle\Title\TitleReader\AnnotationsReader::setRouter")</sup>
   - `setCache::setCache`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/NavigationBundle/Title/TitleReader/AnnotationsReader.php#L48 "Oro\Bundle\NavigationBundle\Title\TitleReader\AnnotationsReader::setCache")</sup>
* The following methods in class `RouteChoiceType`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Form/Type/RouteChoiceType.php "Oro\Bundle\NavigationBundle\Form\Type\RouteChoiceType")</sup> were removed:
   - `setTitleTranslator::setTitleTranslator`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/NavigationBundle/Form/Type/RouteChoiceType.php#L63 "Oro\Bundle\NavigationBundle\Form\Type\RouteChoiceType::setTitleTranslator")</sup>
   - `setReaderRegistry::setReaderRegistry`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/NavigationBundle/Form/Type/RouteChoiceType.php#L71 "Oro\Bundle\NavigationBundle\Form\Type\RouteChoiceType::setReaderRegistry")</sup>
   - `setTitleServiceLink::setTitleServiceLink`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/NavigationBundle/Form/Type/RouteChoiceType.php#L79 "Oro\Bundle\NavigationBundle\Form\Type\RouteChoiceType::setTitleServiceLink")</sup>
* The `AnnotationsReader::__construct(RequestStack $requestStack, Reader $reader)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/NavigationBundle/Title/TitleReader/AnnotationsReader.php#L31 "Oro\Bundle\NavigationBundle\Title\TitleReader\AnnotationsReader")</sup> method was changed to `AnnotationsReader::__construct(Reader $reader, Router $router, Cache $cache)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Title/TitleReader/AnnotationsReader.php#L30 "Oro\Bundle\NavigationBundle\Title\TitleReader\AnnotationsReader")</sup>
* The `RouteChoiceType::__construct(RouterInterface $router, ManagerRegistry $registry, TranslatorInterface $translator)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/NavigationBundle/Form/Type/RouteChoiceType.php#L55 "Oro\Bundle\NavigationBundle\Form\Type\RouteChoiceType")</sup> method was changed to `RouteChoiceType::__construct(RouterInterface $router, TitleReaderRegistry $readerRegistry, TitleTranslator $titleTranslator, ServiceLink $titleServiceLink)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/NavigationBundle/Form/Type/RouteChoiceType.php#L53 "Oro\Bundle\NavigationBundle\Form\Type\RouteChoiceType")</sup>

PlatformBundle
--------------
* Service `jms_serializer.link` was removed.
* The `SerializerExtension::__construct(ServiceLink $serializerLink)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/PlatformBundle/Twig/SerializerExtension.php#L17 "Oro\Bundle\PlatformBundle\Twig\SerializerExtension")</sup> method was changed to `SerializerExtension::__construct(ContainerInterface $container)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/PlatformBundle/Twig/SerializerExtension.php#L18 "Oro\Bundle\PlatformBundle\Twig\SerializerExtension")</sup>
* The `SerializerExtension::$serializerLink`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/PlatformBundle/Twig/SerializerExtension.php#L12 "Oro\Bundle\PlatformBundle\Twig\SerializerExtension::$serializerLink")</sup> property was removed.

SecurityBundle
--------------
* The `AclProtectedFieldTypeExtension::getFieldForbiddenFormError`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SecurityBundle/Form/Extension/AclProtectedFieldTypeExtension.php#L344 "Oro\Bundle\SecurityBundle\Form\Extension\AclProtectedFieldTypeExtension::getFieldForbiddenFormError")</sup> method was removed.
* The `AclProtectedFieldTypeExtension::__construct(SecurityFacade $securityFacade, DoctrineHelper $doctrineHelper, ConfigProvider $configProvider, LoggerInterface $logger)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SecurityBundle/Form/Extension/AclProtectedFieldTypeExtension.php#L53 "Oro\Bundle\SecurityBundle\Form\Extension\AclProtectedFieldTypeExtension")</sup> method was changed to `AclProtectedFieldTypeExtension::__construct(FieldAclHelper $fieldAclHelper, LoggerInterface $logger)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Form/Extension/AclProtectedFieldTypeExtension.php#L40 "Oro\Bundle\SecurityBundle\Form\Extension\AclProtectedFieldTypeExtension")</sup>
* The following properties in class `AclProtectedFieldTypeExtension`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SecurityBundle/Form/Extension/AclProtectedFieldTypeExtension.php "Oro\Bundle\SecurityBundle\Form\Extension\AclProtectedFieldTypeExtension")</sup> were removed:
   - `$securityFacade::$securityFacade`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SecurityBundle/Form/Extension/AclProtectedFieldTypeExtension.php#L30 "Oro\Bundle\SecurityBundle\Form\Extension\AclProtectedFieldTypeExtension::$securityFacade")</sup>
   - `$doctrineHelper::$doctrineHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SecurityBundle/Form/Extension/AclProtectedFieldTypeExtension.php#L33 "Oro\Bundle\SecurityBundle\Form\Extension\AclProtectedFieldTypeExtension::$doctrineHelper")</sup>
   - `$configProvider::$configProvider`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SecurityBundle/Form/Extension/AclProtectedFieldTypeExtension.php#L36 "Oro\Bundle\SecurityBundle\Form\Extension\AclProtectedFieldTypeExtension::$configProvider")</sup>

SegmentBundle
-------------
* Class `Oro/Bundle/SegmentBundle/Entity/Manager/StaticSegmentManager`:
    - method `bindParameters` is deprecated and will be removed. 
    - method `run` now accept also a dynamic segment
* The `DynamicSegmentQueryBuilder::setVirtualRelationProvider`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Query/DynamicSegmentQueryBuilder.php#L54 "Oro\Bundle\SegmentBundle\Query\DynamicSegmentQueryBuilder::setVirtualRelationProvider")</sup> method was removed.
* The `DynamicSegmentQueryBuilder::__construct(RestrictionBuilder $restrictionBuilder, Manager $manager, VirtualFieldProviderInterface $virtualFieldProvider, ManagerRegistry $doctrine)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Query/DynamicSegmentQueryBuilder.php#L39 "Oro\Bundle\SegmentBundle\Query\DynamicSegmentQueryBuilder")</sup> method was changed to `DynamicSegmentQueryBuilder::__construct(ServiceLink $segmentQueryConverterLink, ManagerRegistry $doctrine)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/Query/DynamicSegmentQueryBuilder.php#L25 "Oro\Bundle\SegmentBundle\Query\DynamicSegmentQueryBuilder")</sup>
* The `SegmentFilter::__construct(FormFactoryInterface $factory, FilterUtility $util, ManagerRegistry $doctrine, ServiceLink $dynamicSegmentQueryBuilderLink, ServiceLink $staticSegmentQueryBuilderLink, EntityNameProvider $entityNameProvider, ConfigProvider $entityConfigProvider, ConfigProvider $extendConfigProvider)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Filter/SegmentFilter.php#L59 "Oro\Bundle\SegmentBundle\Filter\SegmentFilter")</sup> method was changed to `SegmentFilter::__construct(FormFactoryInterface $factory, FilterUtility $util, ManagerRegistry $doctrine, SegmentManager $segmentManager, EntityNameProvider $entityNameProvider, ConfigProvider $entityConfigProvider, ConfigProvider $extendConfigProvider)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/Filter/SegmentFilter.php#L53 "Oro\Bundle\SegmentBundle\Filter\SegmentFilter")</sup>
* The `DoctrinePreRemoveListener::__construct(ConfigManager $cm)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/EventListener/DoctrinePreRemoveListener.php#L22 "Oro\Bundle\SegmentBundle\EventListener\DoctrinePreRemoveListener")</sup> method was changed to `DoctrinePreRemoveListener::__construct(ConfigManager $cm, DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/EventListener/DoctrinePreRemoveListener.php#L28 "Oro\Bundle\SegmentBundle\EventListener\DoctrinePreRemoveListener")</sup>
* The `SegmentManager::__construct(EntityManager $em)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Entity/Manager/SegmentManager.php#L18 "Oro\Bundle\SegmentBundle\Entity\Manager\SegmentManager")</sup> method was changed to `SegmentManager::__construct(EntityManager $em, SegmentQueryBuilderRegistry $builderRegistry)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/Entity/Manager/SegmentManager.php#L33 "Oro\Bundle\SegmentBundle\Entity\Manager\SegmentManager")</sup>
* The following properties in class `DynamicSegmentQueryBuilder`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/Query/DynamicSegmentQueryBuilder.php "Oro\Bundle\SegmentBundle\Query\DynamicSegmentQueryBuilder")</sup> were removed:
   - `$restrictionBuilder::$restrictionBuilder`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Query/DynamicSegmentQueryBuilder.php#L19 "Oro\Bundle\SegmentBundle\Query\DynamicSegmentQueryBuilder::$restrictionBuilder")</sup>
   - `$manager::$manager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Query/DynamicSegmentQueryBuilder.php#L22 "Oro\Bundle\SegmentBundle\Query\DynamicSegmentQueryBuilder::$manager")</sup>
   - `$virtualFieldProvider::$virtualFieldProvider`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Query/DynamicSegmentQueryBuilder.php#L28 "Oro\Bundle\SegmentBundle\Query\DynamicSegmentQueryBuilder::$virtualFieldProvider")</sup>
   - `$virtualRelationProvider::$virtualRelationProvider`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Query/DynamicSegmentQueryBuilder.php#L31 "Oro\Bundle\SegmentBundle\Query\DynamicSegmentQueryBuilder::$virtualRelationProvider")</sup>
* The following properties in class `SegmentFilter`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/Filter/SegmentFilter.php "Oro\Bundle\SegmentBundle\Filter\SegmentFilter")</sup> were removed:
   - `$dynamicSegmentQueryBuilderLink::$dynamicSegmentQueryBuilderLink`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Filter/SegmentFilter.php#L33 "Oro\Bundle\SegmentBundle\Filter\SegmentFilter::$dynamicSegmentQueryBuilderLink")</sup>
   - `$staticSegmentQueryBuilderLink::$staticSegmentQueryBuilderLink`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Filter/SegmentFilter.php#L36 "Oro\Bundle\SegmentBundle\Filter\SegmentFilter::$staticSegmentQueryBuilderLink")</sup>
* The following methods in class `SegmentFilter`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/SegmentBundle/Filter/SegmentFilter.php "Oro\Bundle\SegmentBundle\Filter\SegmentFilter")</sup> were removed:
   - `getSegmentQueryBuilder::getSegmentQueryBuilder`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Filter/SegmentFilter.php#L214 "Oro\Bundle\SegmentBundle\Filter\SegmentFilter::getSegmentQueryBuilder")</sup>
   - `isDynamic::isDynamic`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/SegmentBundle/Filter/SegmentFilter.php#L233 "Oro\Bundle\SegmentBundle\Filter\SegmentFilter::isDynamic")</sup>

TranslationBundle
-----------------
* The `LanguageProvider::__construct(ObjectRepository $repository, LocaleSettings $localeSettings, AclHelper $aclHelper)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/TranslationBundle/Provider/LanguageProvider.php#L31 "Oro\Bundle\TranslationBundle\Provider\LanguageProvider")</sup> method was changed to `LanguageProvider::__construct(ManagerRegistry $registry, LocaleSettings $localeSettings, AclHelper $aclHelper)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/TranslationBundle/Provider/LanguageProvider.php#L32 "Oro\Bundle\TranslationBundle\Provider\LanguageProvider")</sup>
* The `LanguageProvider::$repository`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/TranslationBundle/Provider/LanguageProvider.php#L18 "Oro\Bundle\TranslationBundle\Provider\LanguageProvider::$repository")</sup> property was removed.

UIBundle
--------
* The `UiExtension::scrollDataBefore(Twig_Environment $environment, $pageIdentifier, array $data, FormView $formView = null)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/UIBundle/Twig/UiExtension.php#L168 "Oro\Bundle\UIBundle\Twig\UiExtension")</sup> method was changed to `UiExtension::scrollDataBefore(Twig_Environment $environment, $pageIdentifier, array $data, $entity, FormView $formView = null)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/UIBundle/Twig/UiExtension.php#L168 "Oro\Bundle\UIBundle\Twig\UiExtension")</sup>
* The `BeforeListRenderEvent::__construct(Twig_Environment $environment, ScrollData $scrollData, FormView $formView = null)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/UIBundle/Event/BeforeListRenderEvent.php#L34 "Oro\Bundle\UIBundle\Event\BeforeListRenderEvent")</sup> method was changed to `BeforeListRenderEvent::__construct(Twig_Environment $environment, ScrollData $scrollData, $entity, FormView $formView = null)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/UIBundle/Event/BeforeListRenderEvent.php#L40 "Oro\Bundle\UIBundle\Event\BeforeListRenderEvent")</sup>
* The `ConfigSettingsListener::getApplicationUrlConfigKey`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/UIBundle/EventListener/ConfigSettingsListener.php#L31 "Oro\Bundle\UIBundle\EventListener\ConfigSettingsListener::getApplicationUrlConfigKey")</sup> method was removed.

WorkflowBundle
--------------
* Changed implemented interface of  `Oro\Bundle\WorkflowBundle\Model\Variable` class from `Oro\Bundle\ActionBundle\Model\ParameterInterface` to `Oro\Bundle\ActionBundle\Model\EntityParameterInterface`
* Class `Oro\Bundle\WorkflowBundle\Model\VariableGuesser`:
    - now extends `Oro\Bundle\ActionBundle\Model\AbstractGuesser`
    - service `oro_workflow.variable_guesser` has parent defined as `oro_action.abstract_guesser`
* Class `\Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener` auto start workflow part were moved into `\Oro\Bundle\WorkflowBundle\EventListener\WorkflowStartListener`
* Added parameter `$activeOnly` (boolean) with default `false` to method `\Oro\Bundle\WorkflowBundle\Entity\Repository\WorkflowDefinitionRepository::getAllRelatedEntityClasses`
* Class `\Oro\Bundle\WorkflowBundle\EventListener\WorkflowAwareCache` added:
    - **purpose**: to check whether an entity has been involved as some workflow related entity in cached manner to avoid DB calls
    - **methods**:
        - `hasRelatedActiveWorkflows($entity)`
        - `hasRelatedWorkflows($entity)`
    - invalidation of cache occurs on workflow changes events: 
        - `oro.workflow.after_update`
        - `oro.workflow.after_create`
        - `oro.workflow.after_delete`
        - `oro.workflow.activated`
        - `oro.workflow.deactivated`
* Service `oro_workflow.cache` added with standard `\Doctrine\Common\Cache\Cache` interface under namespace `oro_workflow`
* Class `Oro\Bundle\WorkflowBundle\Form\Type\WorkflowReplacementSelectType` renamed to `Oro\Bundle\WorkflowBundle\Form\Type\WorkflowReplacementType`
* Class `Oro\Bundle\WorkflowBundle\Form\Handler\TransitionCustomFormHandler` and service `@oro_workflow.handler.transition.form.page_form` removed (see `Oro\Bundle\WorkflowBundle\Processor\Transition\CustomFormProcessor`)
* Class `Oro\Bundle\WorkflowBundle\Form\Handler\TransitionFormHandler` and service `@oro_workflow.handler.transition.form` removed see replacements:
  - `Oro\Bundle\WorkflowBundle\Processor\Transition\DefaultFormProcessor`
  - `Oro\Bundle\WorkflowBundle\Processor\Transition\DefaultFormStartHandleProcessor`
* Class `Oro\Bundle\WorkflowBundle\Handler\Helper\TransitionHelper` and service `@oro_workflow.handler.transition_helper` removed (see `Oro\Bundle\WorkflowBundle\Processor\Transition\Template\FormSubmitTemplateResponseProcessor`)
* Class `Oro\Bundle\WorkflowBundle\Handler\StartTransitionHandler` and service `@oro_workflow.handler.start_transition_handler` removed (see `Oro\Bundle\WorkflowBundle\Processor\Transition\StartHandleProcessor`)
* Class `Oro\Bundle\WorkflowBundle\Handler\TransitionHandler` and service `@oro_workflow.handler.transition_handler` removed (see `Oro\Bundle\WorkflowBundle\Processor\Transition\TransitionHandleProcessor`)
* Class `Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper`:
  - Constant `Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper::DEFAULT_TRANSITION_TEMPLATE` moved into `Oro\Bundle\WorkflowBundle\Processor\Transition\Template\DefaultFormTemplateResponseProcessor::DEFAULT_TRANSITION_TEMPLATE`
  - Constant `Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper::DEFAULT_TRANSITION_CUSTOM_FORM_TEMPLATE` moved into `Oro\Bundle\WorkflowBundle\Processor\Transition\Template\CustomFormTemplateResponseProcessor::DEFAULT_TRANSITION_CUSTOM_FORM_TEMPLATE`

* Added processor tag `oro_workflow.processor` and `oro_workflow.processor_bag` service to collect processors.
* The following classes were removed:
   - `StartTransitionHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Handler/StartTransitionHandler.php#L21 "Oro\Bundle\WorkflowBundle\Handler\StartTransitionHandler")</sup>
   - `TransitionHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Handler/TransitionHandler.php#L15 "Oro\Bundle\WorkflowBundle\Handler\TransitionHandler")</sup>
   - `TransitionHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Handler/Helper/TransitionHelper.php#L14 "Oro\Bundle\WorkflowBundle\Handler\Helper\TransitionHelper")</sup>
   - `WorkflowReplacementSelectType`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Form/Type/WorkflowReplacementSelectType.php#L10 "Oro\Bundle\WorkflowBundle\Form\Type\WorkflowReplacementSelectType")</sup>
   - `TransitionCustomFormHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Form/Handler/TransitionCustomFormHandler.php#L12 "Oro\Bundle\WorkflowBundle\Form\Handler\TransitionCustomFormHandler")</sup>
   - `TransitionFormHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Form/Handler/TransitionFormHandler.php#L12 "Oro\Bundle\WorkflowBundle\Form\Handler\TransitionFormHandler")</sup>
   - `WorkflowReplacementSearchHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Autocomplete/WorkflowReplacementSearchHandler.php#L16 "Oro\Bundle\WorkflowBundle\Autocomplete\WorkflowReplacementSearchHandler")</sup>
* The following methods in class `WorkflowVariableNormalizer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Serializer/Normalizer/WorkflowVariableNormalizer.php "Oro\Bundle\WorkflowBundle\Serializer\Normalizer\WorkflowVariableNormalizer")</sup> were changed:
  > - `normalizeVariable(Workflow $workflow, ParameterInterface $variable, $variableValue)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Serializer/Normalizer/WorkflowVariableNormalizer.php#L18 "Oro\Bundle\WorkflowBundle\Serializer\Normalizer\WorkflowVariableNormalizer")</sup>
  > - `normalizeVariable(Workflow $workflow, ParameterInterface $variable, array $options)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Serializer/Normalizer/WorkflowVariableNormalizer.php#L34 "Oro\Bundle\WorkflowBundle\Serializer\Normalizer\WorkflowVariableNormalizer")</sup>

  > - `denormalizeVariable(Workflow $workflow, ParameterInterface $variable, $variableValue)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Serializer/Normalizer/WorkflowVariableNormalizer.php#L32 "Oro\Bundle\WorkflowBundle\Serializer\Normalizer\WorkflowVariableNormalizer")</sup>
  > - `denormalizeVariable(Workflow $workflow, ParameterInterface $variable, array $options)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Serializer/Normalizer/WorkflowVariableNormalizer.php#L48 "Oro\Bundle\WorkflowBundle\Serializer\Normalizer\WorkflowVariableNormalizer")</sup>

* The `WorkflowVirtualRelationProvider::__construct(WorkflowRegistry $workflowRegistry, DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Provider/WorkflowVirtualRelationProvider.php#L27 "Oro\Bundle\WorkflowBundle\Provider\WorkflowVirtualRelationProvider")</sup> method was changed to `WorkflowVirtualRelationProvider::__construct(DoctrineHelper $doctrineHelper, Cache $entitiesWithWorkflowCache)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Provider/WorkflowVirtualRelationProvider.php#L33 "Oro\Bundle\WorkflowBundle\Provider\WorkflowVirtualRelationProvider")</sup>
* The `TransitionAssembler::__construct(FormOptionsAssembler $formOptionsAssembler, ExpressionFactory $conditionFactory, ActionFactoryInterface $actionFactory, FormOptionsConfigurationAssembler $formOptionsConfigurationAssembler)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Model/TransitionAssembler.php#L47 "Oro\Bundle\WorkflowBundle\Model\TransitionAssembler")</sup> method was changed to `TransitionAssembler::__construct(FormOptionsAssembler $formOptionsAssembler, ExpressionFactory $conditionFactory, ActionFactoryInterface $actionFactory, FormOptionsConfigurationAssembler $formOptionsConfigurationAssembler, TransitionOptionsResolver $optionsResolver)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/TransitionAssembler.php#L44 "Oro\Bundle\WorkflowBundle\Model\TransitionAssembler")</sup>
* The `VariableAssembler::__construct(WorkflowVariableNormalizer $dataNormalizer)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Model/VariableAssembler.php#L24 "Oro\Bundle\WorkflowBundle\Model\VariableAssembler")</sup> method was changed to `VariableAssembler::__construct(WorkflowVariableNormalizer $dataNormalizer, VariableGuesser $variableGuesser, TranslatorInterface $translator)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/VariableAssembler.php#L39 "Oro\Bundle\WorkflowBundle\Model\VariableAssembler")</sup>
* The `TransitionWidgetHelper::__construct(DoctrineHelper $doctrineHelper, FormFactoryInterface $formFactory, WorkflowAwareSerializer $workflowDataSerializer)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php#L41 "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper")</sup> method was changed to `TransitionWidgetHelper::__construct(DoctrineHelper $doctrineHelper)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php#L17 "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper")</sup>
* The `WorkflowVariablesType::__construct(VariableGuesser $variableGuesser)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Form/Type/WorkflowVariablesType.php#L25 "Oro\Bundle\WorkflowBundle\Form\Type\WorkflowVariablesType")</sup> method was changed to `WorkflowVariablesType::__construct(VariableGuesser $variableGuesser, ManagerRegistry $managerRegistry)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Form/Type/WorkflowVariablesType.php#L35 "Oro\Bundle\WorkflowBundle\Form\Type\WorkflowVariablesType")</sup>
* The `WorkflowItemListener::__construct(DoctrineHelper $doctrineHelper, WorkflowManagerRegistry $workflowManagerRegistry, WorkflowEntityConnector $entityConnector)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L43 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener")</sup> method was changed to `WorkflowItemListener::__construct(DoctrineHelper $doctrineHelper, WorkflowManagerRegistry $workflowManagerRegistry, WorkflowEntityConnector $entityConnector, WorkflowAwareCache $cache)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L33 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener")</sup>
* The `WorkflowDefinitionController::activateFormAction(WorkflowDefinition $workflowDefinition)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Controller/WorkflowDefinitionController.php#L198 "Oro\Bundle\WorkflowBundle\Controller\WorkflowDefinitionController")</sup> method was changed to `WorkflowDefinitionController::activateFormAction(Request $request, WorkflowDefinition $workflowDefinition)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Controller/WorkflowDefinitionController.php#L202 "Oro\Bundle\WorkflowBundle\Controller\WorkflowDefinitionController")</sup>
* The `WorkflowVirtualRelationProvider::$workflowRegistry`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Provider/WorkflowVirtualRelationProvider.php#L18 "Oro\Bundle\WorkflowBundle\Provider\WorkflowVirtualRelationProvider::$workflowRegistry")</sup> property was removed.
* The `VariableGuesser::$formTypeMapping`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Model/VariableGuesser.php#L12 "Oro\Bundle\WorkflowBundle\Model\VariableGuesser::$formTypeMapping")</sup> property was removed.
* The following properties in class `TransitionWidgetHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper")</sup> were removed:
   - `$formFactory::$formFactory`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php#L29 "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper::$formFactory")</sup>
   - `$workflowDataSerializer::$workflowDataSerializer`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php#L32 "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper::$workflowDataSerializer")</sup>
* The following properties in class `WorkflowItemListener`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener")</sup> were removed:
   - `$entitiesScheduledForWorkflowStart::$entitiesScheduledForWorkflowStart`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L30 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::$entitiesScheduledForWorkflowStart")</sup>
   - `$deepLevel::$deepLevel`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L33 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::$deepLevel")</sup>
   - `$workflowRelatedClasses::$workflowRelatedClasses`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L36 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::$workflowRelatedClasses")</sup>
* The `VariableGuesser::addFormTypeMapping`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Model/VariableGuesser.php#L19 "Oro\Bundle\WorkflowBundle\Model\VariableGuesser::addFormTypeMapping")</sup> method was removed.
* The following methods in class `TransitionWidgetHelper`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper")</sup> were removed:
   - `getEntityManager::getEntityManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php#L78 "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper::getEntityManager")</sup>
   - `getTransitionForm::getTransitionForm`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php#L91 "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper::getTransitionForm")</sup>
   - `getTransitionFormTemplate::getTransitionFormTemplate`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php#L126 "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper::getTransitionFormTemplate")</sup>
   - `processWorkflowData::processWorkflowData`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Helper/TransitionWidgetHelper.php#L143 "Oro\Bundle\WorkflowBundle\Helper\TransitionWidgetHelper::processWorkflowData")</sup>
* The `WorkflowItemListener::postFlush`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L125 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::postFlush")</sup> method was removed.
* The `WorkflowManager::isStartAllowedByRecordGroups($entity, array $recordGroups)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowManager.php#L528 "Oro\Bundle\WorkflowBundle\Model\WorkflowManager")</sup> method was changed to `WorkflowManager::isStartAllowedByRecordGroups($entity, Workflow $workflow, array $workflowItems = [])`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Model/WorkflowManager.php#L620 "Oro\Bundle\WorkflowBundle\Model\WorkflowManager")</sup>
* The following methods in class `WorkflowItemListener`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener")</sup> were removed:
   - `scheduleStartWorkflowForNewEntity::scheduleStartWorkflowForNewEntity`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L67 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::scheduleStartWorkflowForNewEntity")</sup>
   - `updateWorkflowItemEntityRelation::updateWorkflowItemEntityRelation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L87 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::updateWorkflowItemEntityRelation")</sup>
   - `getApplicableWorkflowsForStart::getApplicableWorkflowsForStart`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L167 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::getApplicableWorkflowsForStart")</sup>
   - `getWorkflowManager::getWorkflowManager`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L187 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::getWorkflowManager")</sup>
   - `hasWorkflows::hasWorkflows`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/EventListener/WorkflowItemListener.php#L196 "Oro\Bundle\WorkflowBundle\EventListener\WorkflowItemListener::hasWorkflows")</sup>
* The following methods in class `WidgetController`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Bundle/WorkflowBundle/Controller/WidgetController.php "Oro\Bundle\WorkflowBundle\Controller\WidgetController")</sup> were removed:
   - `getTransitionFormHandler::getTransitionFormHandler`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Controller/WidgetController.php#L251 "Oro\Bundle\WorkflowBundle\Controller\WidgetController::getTransitionFormHandler")</sup>
   - `getFormTemplateDataProvider::getFormTemplateDataProvider`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Controller/WidgetController.php#L266 "Oro\Bundle\WorkflowBundle\Controller\WidgetController::getFormTemplateDataProvider")</sup>
* The `WorkflowDefinitionController::getWorkflowsToDeactivation`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Bundle/WorkflowBundle/Controller/WorkflowDefinitionController.php#L258 "Oro\Bundle\WorkflowBundle\Controller\WorkflowDefinitionController::getWorkflowsToDeactivation")</sup> method was removed.

Action Component
----------------
* The `CallServiceMethod::getService`<sup>[[?]](https://github.com/orocrm/platform/tree/2.1.0/src/Oro/Component/Action/Action/CallServiceMethod.php#L87 "Oro\Component\Action\Action\CallServiceMethod")</sup> method was changed to `CallServiceMethod::getService($context)`<sup>[[?]](https://github.com/orocrm/platform/tree/2.2.0/src/Oro/Component/Action/Action/CallServiceMethod.php#L89 "Oro\Component\Action\Action\CallServiceMethod")</sup>
