<?php

namespace Oro\Bundle\EntityConfigBundle\Datagrid;

use Doctrine\ORM\EntityManager;
use Oro\Bundle\DataGridBundle\Datasource\ResultRecordInterface;
use Oro\Bundle\EntityConfigBundle\Attribute\Entity\AttributeFamily;
use Oro\Bundle\SecurityBundle\SecurityFacade;

class AttributeFamilyActionsConfiguration
{
    /** @var SecurityFacade */
    private $securityFacade;

    /** @var EntityManager */
    private $entityManager;

    /**
     * @param SecurityFacade $securityFacade
     * @param EntityManager $entityManager
     */
    public function __construct(SecurityFacade $securityFacade, EntityManager $entityManager)
    {
        $this->securityFacade = $securityFacade;
        $this->entityManager = $entityManager;
    }

    /**
     * @param ResultRecordInterface $record
     * @return array
     */
    public function configureActionsVisibility(ResultRecordInterface $record)
    {
        $attributeFamily = $this->entityManager->getReference(AttributeFamily::class, $record->getValue('id'));

        return [
            'view' => true,
            'edit' => true,
            'delete' => $this->securityFacade->isGranted('delete', $attributeFamily)
        ];
    }
}
