<?php

namespace Oro\Bundle\LayoutBundle\EventListener;

use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;

use Oro\Bundle\LayoutBundle\Loader\ImageFilterLoader;

/**
 * Loads dynamic Imagine filters
 */
class ImagineFilterConfigListener
{
    /** @var ContainerInterface */
    private $container;

    /**
     * @param ContainerInterface $container
     */
    public function __construct(ContainerInterface $container)
    {
        $this->container = $container;
    }

    /**
     * @param GetResponseEvent $event
     */
    public function onKernelRequest(GetResponseEvent $event)
    {
        if ($event->isMasterRequest()) {
            /** @var ImageFilterLoader $loader */
            $loader = $this->container->get('oro_layout.loader.image_filter');
            $loader->load();
        }
    }
}
