<?php

namespace Oro\Bundle\WorkflowBundle\Processor\Transition;

use Oro\Bundle\EntityBundle\ORM\DoctrineHelper;
use Oro\Bundle\WorkflowBundle\Entity\WorkflowItem;
use Oro\Bundle\WorkflowBundle\Processor\Context\TransitionContext;
use Oro\Component\ChainProcessor\ContextInterface;
use Oro\Component\ChainProcessor\ProcessorInterface;

class DefaultFormProcessor implements ProcessorInterface
{
    /** @var DoctrineHelper */
    private $doctrineHelper;

    /**
     * @param DoctrineHelper $doctrineHelper
     */
    public function __construct(DoctrineHelper $doctrineHelper)
    {
        $this->doctrineHelper = $doctrineHelper;
    }

    /**
     * @param ContextInterface|TransitionContext $context
     */
    public function process(ContextInterface $context)
    {
        $request = $context->getRequest();

        $context->setSaved(false);
        if ($request->isMethod('POST')) {
            $form = $context->getForm();
            $form->submit($request);

            if ($form->isValid()) {
                $context->getWorkflowItem()->setUpdated();
                $this->doctrineHelper->getEntityManager(WorkflowItem::class)->flush();

                $context->setSaved(true);
            }
        }
    }
}
